#include <joyos.h>

//initiallizes gyro
//initiallized and sets gain for heading and velocity PID
void init_controllers(){

	gyro_init (11, 1400000, 1500L);

	servo_set_pos(0, 445);
	servo_set_pos(1, 255);
	servo_set_pos(2, 75);

	float kP = HEADING_GAIN_PROPORTIONAL; //proportional gain
	float kI = HEADING_GAIN_INTEGRAL; //integral gain
	float kD = HEADING_GAIN_DERIVATIVE; //derivative gain

	init_pid( &headingPID,
		kP,
		kI,
		kD,
		&heading_select,
		&setHeading);   //----------------------------------- PASS THRU TO FINAL MOTOR VEL SET

	headingPID.goal = 0;  //Initializes controller with a heading in mind, could be a bad idea
	headingPID.enabled = true;

	float kp = VELOCITY_GAIN_PROPORTIONAL; //proportional gain
	float ki = VELOCITY_GAIN_INTEGRAL; //integral gain
	float kd = VELOCITY_GAIN_DERIVATIVE; //derivative gain

	init_pid( &velPID,
		kp,
		ki,
		kd,
		&line_dist,       //straight line distance to point
		&setTranslation); //--------------------------------  PASS THRU TO FINAL MOTOR VEL SET

	velPID.goal = 0;
	velPID.enabled = true;
	//printf("PID initialized\n");
}