#ifndef STRATEGY_H
#define STRATEGY_H

#define IDLE (0)
#define TURNING (1)
#define MOVING (2)
#define CAPTURE (3)
#define FACING (4)
#define PULL (5)
#define DUMP (6)

#define BLUE (1)
#define RED (0)

#define CENTER_DIST_ERR (400.)

char newCommand;

char team;

struct Command currentCommand;

int nBallsCollected;
bool dumping;

//prevents strategy from calling on current command while transitioning
struct lock current_command_lock; //create the lock object

void set_command_idle(void);
void set_command_capture(void);
void set_command_heading(float _angle);
void set_command_point( int _nodeIndex );
void set_command_pull_lever(int territoryID);	
void set_command_face_point( int _nodeIndex );
void set_command_dump(void);
int big_dump(int territoryIndex);
int balls(int territoryIndex);
int turn_and_move( int _nodeIndex );
int capture(int _territoryIndex);
int pathfind_to_point( int _currentIndex, int _goalIndex );

float get_territory_difference(int t1,int t2);
int reached_heading(void);
int reached_point(void);
int territory_captured(int _territory);
int pull_success(void);
int done_dump(void);

int strategy(void);

#endif