/*
 * The MIT License
 *
 * Copyright (c) 2007 MIT 6.270 Robotics Competition
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 */



#include <joyos.h>
#include <lib/pid.h>
#include <PIDmanagement.h>
#include <encodernav.h>

//make sure libraries are on top, at least for now  O.o

uint8_t forwardVel = 150;


int usetup (void) {
	  gyro_init (11, 1400000, 500L);
	  gyro_set_degrees(0);
    return 0;
}

int umain (void) {
     float kP = 2; //proportional gain
  float kI = 0; //integral gain
  float kD = -0.5; //derivative gain

  struct pid_controller headingPID;

  init_pid( &headingPID,
            kP,
            kI,
            kD,
            &gyro_get_degrees,
            &setVelocities);

  headingPID.goal = 0;
  headingPID.enabled = true;
  
  
  while (true){
	  //find new correction and send to motors---------------------------
    update_pid(&headingPID);

	uint16_t runCount = 0;

	//Print the motor and heading info-------------------------------
	
		//printf("Motor 0 set to: %04d  Motor 1 set to: %04d  Heading: %07.2f  Correction Amount: %04.0f  Runs: %ld\n", motor_get_vel(0), motor_get_vel(1), gyro_get_degrees(), PIDCorrectionVal, runCount);
		printf("Clicks: %u  estDist: %05.2f\n", encoder_read(24), get_dist(24));

		/*if (runCount == 100){
			headingPID.goal = 90;
		}
		
		if(runCount>150){
	headingPID.goal += frob_read_range(0,12);
	
		}
		runCount++;*/
  }
	
    return 0;
}
